;; Copyright (c) Iwata <iwata@quasiquote.org>
;;
;; Permission is hereby granted, free of charge, to any person obtaining
;; a copy of this software and associated documentation files (the
;; "Software"), to deal in the Software without restriction, including
;; without limitation the rights to use, copy, modify, merge, publish,
;; distribute, sublicense, and/or sell copies of the Software, and to
;; permit persons to whom the Software is furnished to do so, subject to
;; the following conditions:
;;
;; The above copyright notice and this permission notice shall be included
;; in all copies or substantial portions of the Software.
;;
;; THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
;; EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
;; MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
;; IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
;; CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
;; TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
;; SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

(define-module lazy-ffi
  (export lazy-ffi:strerr)
  (export lazy-ffi:open)
  (export lazy-ffi:close)
  (export lazy-ffi:function)
  (export lazy:void lazy:int lazy:double lazy:ptr lazy:char
          lazy:scheme lazy:scheme_ptr lazy:string))

(select-module lazy-ffi)
(dynamic-load "lazy-ffi")

(define-constant lazy:void 0)
(define-constant lazy:int 1)    1
(define-constant lazy:double 2)
(define-constant lazy:ptr 3)
(define-constant lazy:char 4)
(define-constant lazy:scheme 5)
(define-constant lazy:scheme_ptr 6)
(define-constant lazy:string 7)

;; chicken lazy-ffi like interface
(define (lazy-ffi:function dl name ret . l)
  (lazy-ffi:call dl ret name l))


(provide "lazy-ffi")

